Package org.kapott.hbci.passport.storage.format.legacy

## Class AbstractConverterXML

- java.lang.Object
- - org.kapott.hbci.passport.storage.format.legacy.AbstractConverter
  - - org.kapott.hbci.passport.storage.format.legacy.AbstractConverterXML

All Implemented Interfaces:
  `Converter`

Direct Known Subclasses:
  `ConverterAnonymous`, `ConverterRDHNew`

    public abstract class AbstractConverterXML
    extends AbstractConverter

Abstrakte Basis-Implementierung des Converter fuer Passports, die intern XML-basiert speichern.

### Constructor Summary

Constructors
`AbstractConverterXML()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`protected void` `createElement​(org.w3c.dom.Document doc, org.w3c.dom.Element root, java.lang.String elemName, java.lang.String elemValue)` Erzeugt ein XML-Element.
`protected void` `createKeyElement​(org.w3c.dom.Document doc, org.w3c.dom.Element root, java.lang.String owner, java.lang.String type, java.lang.String part, HBCIKey key)` Erzeugt die XML-Elemente fuer den Schluessel.
`protected void` `createPropsElement​(org.w3c.dom.Document doc, org.w3c.dom.Element root, java.lang.String elemName, java.util.Properties p)` Erzeugt ein Properties-Element.
`protected abstract void` `fill​(org.w3c.dom.Document doc, org.w3c.dom.Element root, PassportData data)` Schreibt die Daten in die XML-Struktur.
`protected HBCIKey` `getElementKey​(org.w3c.dom.Element root, java.lang.String owner, java.lang.String type, java.lang.String part)` Parst den Schluessel aus der XML-Struktur.
`protected java.util.Properties` `getElementProps​(org.w3c.dom.Element root, java.lang.String name)` Liefert die Werte aus dem XML-Teil als Properties.
`protected java.lang.String` `getElementValue​(org.w3c.dom.Element root, java.lang.String name)` Liefert einen einzelnen Wert.
`protected org.w3c.dom.Element` `read​(java.io.InputStream is)` Parst die XML-Datei und liefert das Root-Element.
`void` `save​(PassportData data, java.io.OutputStream os)` Speichert die Passport-Daten.

### Methods inherited from class org.kapott.hbci.passport.storage.format.legacy.AbstractConverter

`getSalt`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.kapott.hbci.passport.storage.format.legacy.Converter

`load, supports`

### Constructor Detail

#### AbstractConverterXML

    public AbstractConverterXML()

### Method Detail

#### read

    protected org.w3c.dom.Element read​(java.io.InputStream is)
                                throws java.lang.Exception

Parst die XML-Datei und liefert das Root-Element.

Parameters:
  `is` - der InputStream.
Returns:
  das Root-Element.
Throws:
  `java.lang.Exception`

#### save

    public void save​(PassportData data,
                     java.io.OutputStream os)
              throws java.lang.Exception

Description copied from interface: `Converter`
Speichert die Passport-Daten.

Parameters:
  `data` - die Daten.
  `os` - der Stream, in den die Daten geschrieben werden.
Throws:
  `java.lang.Exception` - wenn es beim Schreiben der Daten zu einem Fehler kam.
See Also:
  `Converter.save(org.kapott.hbci.passport.storage.PassportData, java.io.OutputStream)`

#### fill

    protected abstract void fill​(org.w3c.dom.Document doc,
                                 org.w3c.dom.Element root,
                                 PassportData data)

Schreibt die Daten in die XML-Struktur.

Parameters:
  `doc` - das Dokument.
  `root` - das Root-Element.
  `data` - die zu schreibenden Daten.

#### getElementValue

    protected java.lang.String getElementValue​(org.w3c.dom.Element root,
                                               java.lang.String name)

Liefert einen einzelnen Wert.

Parameters:
  `root` - das Element.
  `name` - der Name des Elements.
Returns:

#### getElementProps

    protected java.util.Properties getElementProps​(org.w3c.dom.Element root,
                                                   java.lang.String name)

Liefert die Werte aus dem XML-Teil als Properties.

Parameters:
  `root` - Das Basis-Element.
  `name` - der Name des Elements.
Returns:
  die Properties.

#### getElementKey

    protected HBCIKey getElementKey​(org.w3c.dom.Element root,
                                    java.lang.String owner,
                                    java.lang.String type,
                                    java.lang.String part)
                             throws java.lang.Exception

Parst den Schluessel aus der XML-Struktur.

Parameters:
  `root` - das Root-Element.
  `owner` - Owner.
  `type` - Typ.
  `part` - Teil.
Returns:
  der Schluessel.
Throws:
  `java.lang.Exception`

#### createElement

    protected void createElement​(org.w3c.dom.Document doc,
                                 org.w3c.dom.Element root,
                                 java.lang.String elemName,
                                 java.lang.String elemValue)

Erzeugt ein XML-Element.

Parameters:
  `doc` - das Dokument.
  `root` - das Root-Element.
  `elemName` - der Name des Elements.
  `elemValue` - der Wert des Elements.

#### createPropsElement

    protected void createPropsElement​(org.w3c.dom.Document doc,
                                      org.w3c.dom.Element root,
                                      java.lang.String elemName,
                                      java.util.Properties p)

Erzeugt ein Properties-Element.

Parameters:
  `doc` - das Dokument.
  `root` - das Root-Element.
  `elemName` - der Name des Element.s
  `p` - die Properties.

#### createKeyElement

    protected void createKeyElement​(org.w3c.dom.Document doc,
                                    org.w3c.dom.Element root,
                                    java.lang.String owner,
                                    java.lang.String type,
                                    java.lang.String part,
                                    HBCIKey key)

Erzeugt die XML-Elemente fuer den Schluessel.

Parameters:
  `doc` - das Dokument.
  `root` - das Root-Element.
  `owner` - Owner.
  `type` - Typ.
  `part` - Teil.
  `key` - Schluessel.